%define debug_package %{nil}
%define _use_internal_dependency_generator 0

%define	rel			1
%define	VirtualEnvironment	%{name}-%{version}-%{rel}
%define VirtualEnvironmentPath	%{_prefix}/local/lib/PythonVirtualEnvironments

%define	__find_provides		/tmp/myfind-provides
%define	__find_requires		/tmp/myfind-requires


%define	_build_id_links 	none
%define	__python		/usr/bin/python3

Summary:	Mac OS Artifact Parsing Tool

Packager:	Lawrence R. Rogers (lrr@cert.org)

Vendor:		cert.org
Name:		mac_apt
Version:	0.7
Release:	%{rel}%{?dist}
URL:		https://github.com/ydkhatri/mac_apt/wiki

License:	GPL

Group:		Applications/Forensics Tools
Source1:	%{name}-%{version}.tar.gz
Source2:	libewf-20140808.tar.gz
BuildRoot:	%{_tmppath}/rpm-root-%{name}-v%{version}
%if 0%{?centos} == 8 || 0%{?rhel} == 8
BuildRequires:	python3-virtualenv python3-devel
%endif
%if 0%{?centos} == 7
BuildRequires:	python36-virtualenv python36-devel
%endif
%if 0%{?fedora} >= 27
BuildRequires:	python3-virtualenv python3-devel
%endif
BuildRequires:	bzip2-devel kernel-headers openssl-devel

%description
DESCIPTION

%prep
%setup -cT
%if 0%{?fedora} >= 29
virtualenv %{VirtualEnvironment}
%else
%if 0%{?centos} >= 7 || 0%{?rhel} >= 7 || 0%{?fedora}
virtualenv-3 %{VirtualEnvironment}
%else 
virtualenv %{VirtualEnvironment}
%endif
%endif
cd %{VirtualEnvironment}
tar zxf %{SOURCE1}
tar zxf %{SOURCE2}
cat > %{__find_provides}  <<EOF
#!/bin/sh
grep -v /site-packages/ | /usr/lib/rpm/rpmdeps --define="_use_internal_dependency_generator 1" --provides
EOF
cat > %{__find_requires} <<EOF
#!/bin/sh
grep -v /site-packages/ | /usr/lib/rpm/rpmdeps --define="_use_internal_dependency_generator 1" --requires
EOF
chmod 755 %{__find_provides} %{__find_requires}

%build
sh -c "cd %{VirtualEnvironment}; source bin/activate; pip3 install %{name}-%{version}/other_dependencies/pyaff4-0.31-yk.zip; echo ignore errors"
sh -c "cd %{VirtualEnvironment}; source bin/activate; pip3 install %{name}-%{version}/other_dependencies/pyaff4-0.31-yk.zip"
sh -c "cd %{VirtualEnvironment}; source bin/activate; cd libewf*; python3 setup.py build; python3 setup.py install; cd ..; rm -rf libewf*"
sh -c "cd %{VirtualEnvironment}; source bin/activate; pip3 install biplist construct==2.9.45 xlsxwriter plistutils kaitaistruct lz4 pytsk3==20170802 libvmdk-python==20181227 pycryptodome cryptography pybindgen==0.21.0 pillow pyliblzfse"

%install
%{__mkdir_p} %{buildroot}/%{VirtualEnvironmentPath}
find %{VirtualEnvironment} | cpio -pdmv %{buildroot}/%{VirtualEnvironmentPath}
cd %{buildroot}/%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin
for f in $(grep -l %{VirtualEnvironment} $(find . -maxdepth 1 -type f))
do
	sed --in-place "s=/.*%{VirtualEnvironment}=%{VirtualEnvironmentPath}/%{VirtualEnvironment}=" $f
done
mkdir -p %{buildroot}/%{_bindir}
cat > %{buildroot}/%{_bindir}/mac_apt << 'EOF'
#!/bin/sh

N=$(basename $0)
MA=%{VirtualEnvironment}
VE=%{VirtualEnvironmentPath}

if [ -d $VE ]; then
	case "$N" in
	*.py)
		;;
	*)
		N=$N.py
		;;
	esac
	exec sh -c "source $VE/$MA/bin/activate; python3 $VE/$MA/%{name}-%{version}/$N \"$@\""
else
	echo $0 cannot be found
	exit 1
fi
EOF
for app in mac_apt.py mac_apt_artifact_only{,.py} mac_apt_mounted_sys_data{,.py}
do
	ln %{buildroot}/%{_bindir}/mac_apt %{buildroot}/%{_bindir}/$app
done

%post
sh -c "source %{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin/activate; pip3 install --upgrade --force-reinstall pillow"

%files
%defattr(0644, root, root, 0755)
%attr(0755,root,root)	%{_bindir}/*
%attr(0755,root,root)	%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin/*
%{VirtualEnvironmentPath}/%{VirtualEnvironment}

%changelog
* Tue Sep 22 2020 Lawrence R. Rogers <lrr@cert.org> 0.7-1
* Release 0.7-1
	Initial release into LiFTeR
	Version 0.7
